#include "RLDoom_Color.h"
#include "RLDoom_Utils.h"

RLDoom::Graphics::PlayPal RLDoom::Graphics::LoadPlayPal(std::string data)
{
	PlayPal retval;
	for (int i = 0; i < data.size() / 768; i++) {
		RLDoom::Graphics::Palette p;
		std::string paletteData = RLDoom::Utils::Strings::IterativeStringExcerpt(data, i * 768, 768);
		for (int j = 0; j < 256; j++) {
			DoomColor color;
			color.r = paletteData[j * 3];
			color.g = paletteData[j * 3 + 1];
			color.b = paletteData[j * 3 + 2];
			p.push_back(color);
		}
		retval.push_back(p);
	}
	return retval;
}

RLDoom::Graphics::ColorMapFile RLDoom::Graphics::LoadColorMapFile(std::string data)
{
	ColorMapFile retval;

	for (int i = 0; i < data.size() / 256; i++) {
		ColorMap colormap;
		std::string colormapdata = RLDoom::Utils::Strings::IterativeStringExcerpt(data, i * 256, 256);
		for (int j = 0; j < colormapdata.size(); j++) {
			colormap.push_back((PaletteColor)colormapdata[j]);
		}
		retval.push_back(colormap);
	}

	return retval;
}
