#include "RLDoom_Patch.h"
#include "RLDoom_Utils.h"

RLDoom::Graphics::Patch RLDoom::Graphics::LoadPatch(std::string data)
{
	Patch retval;
	retval.width = RLDoom::Utils::Strings::StringIndexToInteger_2b_le(data, 0);
	retval.height = RLDoom::Utils::Strings::StringIndexToInteger_2b_le(data, 2);
	retval.left = RLDoom::Utils::Strings::StringIndexToInteger_2b_le(data, 4);
	retval.top = RLDoom::Utils::Strings::StringIndexToInteger_2b_le(data, 6);
	retval.pixels.resize(retval.width * retval.height);
	retval.columnsofs.resize(retval.width);
	for (int i = 0; i < retval.columnsofs.size(); i++) {
		retval.columnsofs[i] = RLDoom::Utils::Strings::StringIndexToInteger_4b_le(data, 8 + i * 4);
	}
	for (int i = 0; i < retval.columnsofs.size(); i++) {
		uint8_t rowstart = 0;
		
		bool running = true;
		
		int offset = 0;

		while (running) {
			rowstart = data[retval.columnsofs[i] + offset];
			if (rowstart == 255) {
				running = false;
				break;
			}
			uint8_t pixelCount = data[retval.columnsofs[i] + 1 + offset];
			uint8_t dummy1 = data[retval.columnsofs[i] + 2 + offset];
			for (int j = 0; j < pixelCount; j++) {
				retval.pixels[(j + rowstart) * retval.width + i] = data[retval.columnsofs[i] + 3 + j + offset];
				std::cout << "Writing to " << (j + rowstart) << ":" << i << "\n";
			}
			offset += 3 + pixelCount + 1;

		}
	}

	return retval;
}
