#include "RLDoom_FileSystem.h"
#include "RLDoom_Patch.h"
#include "RLDoom_Color.h"

#include <raylib.h>

int main() {
	InitWindow(640, 400, "RLDoom");
	SetTargetFPS(60);
	SetExitKey(0);


	RLDoom::FileSystem::WAD wad;
	RLDoom::Graphics::ColorMapFile colormap;
	RLDoom::Graphics::PlayPal playpal;
	RLDoom::Graphics::Patch titlepic;
	Image titlepicImage = GenImageColor(320, 200, BLANK);
	Texture2D titlepicTexture = LoadTextureFromImage(titlepicImage);

	while (!WindowShouldClose()) {
		BeginDrawing();
		ClearBackground(BLACK);
		DrawText("Drop an IWAD here to see its TITLEPIC.\nOnce an IWAD is loaded, you can drop PWADs.", 0, 0, 10, WHITE);
		if (IsFileDropped()) {
			FilePathList droppedFiles = LoadDroppedFiles();
			for (int i = 0; i < droppedFiles.count; i++) {
				wad = RLDoom::FileSystem::WAD(droppedFiles.paths[i]);
				for (int j = 0; j < wad.lumpCount; j++) {
					if (wad.getLumps()[j].name == "COLORMAP") {
						colormap = RLDoom::Graphics::LoadColorMapFile(wad.getLumps()[j].data);
					}
					if (wad.getLumps()[j].name == "PLAYPAL") {
						playpal = RLDoom::Graphics::LoadPlayPal(wad.getLumps()[j].data);
					}
					if (wad.getLumps()[j].name == "TITLEPIC") {
						titlepic = RLDoom::Graphics::LoadPatch(wad.getLumps()[j].data);
						for (int y = 0; y < titlepic.height; y++) {
							for (int x = 0; x < titlepic.width; x++) {
								ImageDrawPixel(&titlepicImage, x, y, {
									playpal[0][colormap[0][titlepic.pixels[y * titlepic.width + x]]].r,
									playpal[0][colormap[0][titlepic.pixels[y * titlepic.width + x]]].g,
									playpal[0][colormap[0][titlepic.pixels[y * titlepic.width + x]]].b,
									255
								});
							}
						}
						UnloadTexture(titlepicTexture);
						titlepicTexture = LoadTextureFromImage(titlepicImage);
					}
				}
			}
			UnloadDroppedFiles(droppedFiles);
		}
		DrawTextureEx(titlepicTexture, { 0,0 }, 0, 2, WHITE);
		EndDrawing();
	}

	


	UnloadTexture(titlepicTexture);
	CloseWindow();
}